libcamera: libcamera::MappedFrameBuffer Class Reference

libcamera v0.5.0 Supporting cameras in Linux since 2019 |

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
libcamera::MappedFrameBuffer Class Reference

Map a FrameBuffer using the MappedBuffer interface. More...

Inheritance diagram for libcamera::MappedFrameBuffer:
[legend]
Collaboration diagram for libcamera::MappedFrameBuffer:
[legend]

## Public Types
enum class | MapFlag { Read = 1 << 0 , Write = 1 << 1 , ReadWrite = Read | Write }
| Specify the mapping mode for the FrameBuffer. More...
using | MapFlags = Flags<MapFlag>
| A bitwise combination of MappedFrameBuffer::MapFlag values.
Public Types inherited from libcamera::MappedBuffer
using | Plane = Span<uint8_t>
| A mapped region of memory accessible to the CPU.

## Public Member Functions
| MappedFrameBuffer (const FrameBuffer *buffer, MapFlags flags)
| Map all planes of a FrameBuffer.
Public Member Functions inherited from libcamera::MappedBuffer
| MappedBuffer (MappedBuffer &&other)
| Move constructor, construct the MappedBuffer with the contents of other using move semantics.
MappedBuffer & | operator= (MappedBuffer &&other)
| Move assignment operator, replace the mappings with those of other.
bool | isValid () const
| Check if the MappedBuffer instance is valid.
int | error () const
| Retrieve the map error status.
const std::vector< Plane > & | planes () const
| Retrieve the mapped planes.

## Additional Inherited Members
Protected Member Functions inherited from libcamera::MappedBuffer
| MappedBuffer ()
| Construct an empty MappedBuffer.
Protected Attributes inherited from libcamera::MappedBuffer
int | error_
| Stores the error value if present.
std::vector< Plane > | planes_
| Stores the internal mapped planes.
std::vector< Plane > | maps_
| Stores the mapped buffer.

## Detailed Description

Map a FrameBuffer using the MappedBuffer interface.

## Member Enumeration Documentation

## ◆ MapFlag

enum class libcamera::MappedFrameBuffer::MapFlag
| strong

Specify the mapping mode for the FrameBuffer.

Enumerator
Read | Create a read-only mapping.
Write | Create a write-only mapping.
ReadWrite | Create a mapping that can be both read and written.

## Constructor & Destructor Documentation

## ◆ MappedFrameBuffer()

libcamera::MappedFrameBuffer::MappedFrameBuffer | ( | const FrameBuffer * | buffer,
|  | MapFlags | flags )

Map all planes of a FrameBuffer.

Parameters

  [in] | buffer | FrameBuffer to be mapped
  [in] | flags | Protection flags to apply to map

Construct an object to map a frame buffer for CPU access. The mapping can be made as Read only, Write only or support Read and Write operations by setting the MapFlag flags accordingly.

The documentation for this class was generated from the following files:

- include/libcamera/internal/mapped_framebuffer.h
- src/libcamera/mapped_framebuffer.cpp